<?php
namespace Ems\portalGestor\Controller;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Request;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Response\{ Message, Error };
use Zeedhi\Framework\DataSource\DataSet;

use Ems\portalGestor\Service\ParamOrgService;
use Ems\portalGestor\Util\ExpectedException;

class ParamOrgController {
    /** @var ParamOrgService */
    protected $paramOrgService;

    public function __construct(
        ParamOrgService $paramOrgService
    ) {
      $this->paramOrgService = $paramOrgService;
    }

    public function getValorReferencia(
        Request\Filter $request,
        Response $response
    ) {
        try {
            $row = $request->getParameters();

            $valor = $this->paramOrgService->getValorReferencia(
                $row
            );

            $dataSet = [
                'valor' => $valor,
            ];

            $response->addDataSet(new DataSet('data', $dataSet));
        } catch (ExpectedException $e) {
            $response->addMessage(new Message($e->getMessage(), Message::TYPE_ERROR));
        } catch (\Exception $e) {
            $response->setError(new Error($e->getMessage(), $e->getCode(), $e->getTrace()));
        }
    }
}