<?php
namespace EMS\portalGestor\Service;

use EMS\portalGestor\Util\HcmServices;

class SituacaoFuncionalService {

    /** @var HcmServices */
    protected $hcmServices;

    public function __construct(
        HcmServices $hcmServices
    ) {
        $this->hcmServices = $hcmServices;
    }

    public function getUltimaSituacaoFuncional(
        int     $nrOrg,
        int     $nrVinculo,
        int     $nrperiodoapuracacao
    ): Array {
        $hcmServicesRoute = 'getUltimaSituacaoFuncional';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRVINCULOM'            => $nrVinculo,
                'NRPERIODOAPURACACAO'   => $nrperiodoapuracacao,
            ],
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $ultimaSituacaoFuncional = $response['dataset'][$hcmServicesRoute];

        return $ultimaSituacaoFuncional;
    }

    public function getPeriodosEstabilidade(
        int     $nrOrg,
        int     $nrVinculo
    ): Array {
        $hcmServicesRoute = 'getPeriodosEstabilidade';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'NRVINCULOM'            => $nrVinculo,
            ],
        ];

        $response = $this->hcmServices->send($hcmServicesRoute, $params, $nrOrg);
        $ultimaSituacaoFuncional = $response['dataset'][$hcmServicesRoute];

        return $ultimaSituacaoFuncional;
    }

}