CREATE OR REPLACE PROCEDURE GERANF_MPR_VENDA(
   P_CDEMPRESA    IN  EMPRESA.CDEMPRESA%TYPE,
   P_CDINSCESTA   IN  INSCRESTAD.CDINSCESTA%TYPE,
   P_DTINICIAL    IN  NOTAFISCAL.DTENTRSAID%TYPE,
   P_DTFINAL      IN  NOTAFISCAL.DTENTRSAID%TYPE,
   P_CDCTRLNUMENF IN  SERIENF.CDCTRLNUMENF%TYPE,
   P_CDOPERACAO   IN  NOTAFISCAL.CDTIPOOPER%TYPE)

IS
   V_CDCLIENTE    CLIENTE.CDCLIENTE%TYPE;
   V_CDMODDOCFISC CLIENTE.CDMODDOCFISC%TYPE;
   V_NRNOTAANTE   NOTAFISCAL.NRNOTAFISC%TYPE;
   V_FILIPROC     NOTAFISCAL.CDFILIAL%TYPE;
   V_DSOBSFISCIT  IMPOSTONF.DSOBSFISCIT%TYPE;

   V_NRLANCTONF         VARCHAR2(20);
   V_NRLANCTEMP         VARCHAR2(20);
   V_NRNOTAFISC         VARCHAR2(20);
   V_LANCTEMP           VARCHAR2(20);
   V_SEQUIMPOSTNF       VARCHAR2(02);
   V_NRSEQUITVEND       VARCHAR2(02);
   V_INCIDENCIA         VARCHAR2(01);
   V_IDTPIJURNF         VARCHAR2(01);
   V_NRINSJURNF         VARCHAR2(20);
   V_CDGRUPOFISC        VARCHAR2(03);
   V_PAISORIG           VARCHAR2(04);
   V_ESTAORIG           VARCHAR2(02);
   V_MUNIORIG           VARCHAR2(04);
   V_PAISDEST           VARCHAR2(04);
   V_ESTADEST           VARCHAR2(02);
   V_IDENDEMIS          VARCHAR2(01);
   V_NRALIQTEMP         VARCHAR2(14);
   V_SITUTRIBPR         VARCHAR2(03);
   V_TRATIMPST          VARCHAR2(01);
   V_IDTRIMPSTII        VARCHAR2(01);
   V_CSTTEMP            VARCHAR2(14);
   V_ALIQTEMP           VARCHAR2(14);
   V_INCITEMP           VARCHAR2(14);
   V_CFOPTEMP           VARCHAR2(14);
   V_FISOPEITEM         VARCHAR2(11);
   V_CDIMPOSTO          VARCHAR2(02);
   V_NRCUPOM            VARCHAR2(10);
   V_IDINTEREST         VARCHAR2(01);
   V_IDINTERNA          VARCHAR2(01);

   V_TAMNF              NUMBER(11);
   V_IDUTSERECFNF       VARCHAR2(10);
   V_IDUTNRCUPOMNF      VARCHAR2(10);
   V_SERIE              VARCHAR2(10);
   V_IMPOSTOIT          NUMBER;
   V_CONTABCALC         NUMBER;
   V_PARDEDTMP          NUMBER;
   V_PREDBCTMP          NUMBER;
   V_ALIQUTMP           NUMBER;
   V_BASECALC           NUMBER;
   V_TAXABASECALC       NUMBER;
   V_TAXAALIQUOTA       NUMBER;
   V_BASECALCIT         NUMBER;
   V_PERDBCALC          NUMBER;
   V_LIQUIITEM          NUMBER;
BEGIN
   BEGIN
      SELECT IDUTSERECFNF, IDUTNRCUPOMNF
        INTO V_IDUTSERECFNF, V_IDUTNRCUPOMNF
        FROM INSCRESTAD
       WHERE CDINSCESTA = P_CDINSCESTA
         AND CDEMPRESA  = P_CDEMPRESA;
   EXCEPTION
     WHEN NO_DATA_FOUND THEN
       V_IDUTSERECFNF := 'N';
       V_IDUTNRCUPOMNF := 'N';
   END;

   FOR C_CORPONF IN (SELECT VD.CDEMPRESA, FI.CDINSCESTA, FI.CDINSCMUNI, FI.CDFILIAL, VD.DTENTRVENDA, P.NRTAMNUMNFUT,
                            MAX(VD.NRCUPOMFIS) NRCUPOMFIM, MIN(VD.NRCUPOMFIS) NRCUPOMINI,
                            SUM(TRUNC((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL)),2)- NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) AS VRVENDA,
                            VD.NRCUPOMFIS, VD.CDCAIXA
                     FROM VENDA VD, FILIAL FI, ITEMVENDA IT, PARAMFILIAL P, CAIXAPERS CX,

                          (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                             FROM MOVCAIXA
                            WHERE IDTIPOMOVIVE <> 'T' )MV,

                          (SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND
                             FROM ITVENDAIMPOS IV, IMPOSTO I
                            WHERE IV.CDIMPOSTO    = I.CDIMPOSTO
                              AND I.IDTPIMPOSFIS <> 'S' ) IP

                     WHERE FI.CDEMPRESA    = P_CDEMPRESA         AND
                           FI.CDINSCESTA   = P_CDINSCESTA        AND
                           VD.CDFILIAL     = FI.CDFILIAL         AND
                           VD.IDSITUVENDA  = 'O'                 AND
                           IDTIPOVENDA     = 'S'                 AND
                           VD.DTENTRVENDA BETWEEN P_DTINICIAL    AND P_DTFINAL AND
                           VD.CDEMPRESA    = P_CDEMPRESA         AND
                           VD.CDFILIAL     = IT.CDFILIAL         AND
                           VD.CDCAIXA      = IT.CDCAIXA          AND
                           VD.NRSEQVENDA   = IT.NRSEQVENDA       AND
                           FI.CDFILIAL     = P.CDFILIAL          AND
                           VD.CDFILIAL     = MV.CDFILIAL         AND
                           VD.CDCAIXA      = MV.CDCAIXA          AND
                           VD.NRSEQVENDA   = MV.NRSEQVENDA       AND
                           IT.CDFILIAL     = IP.CDFILIAL(+)      AND
                           IT.CDCAIXA      = IP.CDCAIXA(+)       AND
                           IT.NRSEQVENDA   = IP.NRSEQVENDA(+)    AND
                           IT.NRSEQUITVEND = IP.NRSEQUITVEND(+)  AND
                           CX.CDFILIAL     = VD.CDFILIAL         AND
                           CX.CDCAIXAPERS  = VD.CDCAIXA          AND
                           CX.IDTIPOSISTEMA <> 'SPS'
                     GROUP BY VD.CDEMPRESA, FI.CDINSCESTA, FI.CDINSCMUNI, FI.CDFILIAL, VD.DTENTRVENDA,
                           P.NRTAMNUMNFUT, VD.NRCUPOMFIS, VD.CDCAIXA
                     ORDER BY VD.DTENTRVENDA ) LOOP

      IF V_IDUTSERECFNF = 'S' THEN
         SELECT MAX(NRECFTURCAIX)
           INTO V_SERIE
           FROM TURCAIXA
          WHERE CDFILIAL = C_CORPONF.CDFILIAL
            AND CDCAIXA = C_CORPONF.CDCAIXA;
      ELSE
         V_SERIE := 'ECF';
      END IF;

      SELECT MAX(NRNOTAFISC)
        INTO V_NRNOTAANTE
        FROM NOTAFISCAL
       WHERE CDEMPRESA  = P_CDEMPRESA
         AND CDINSCESTA = P_CDINSCESTA
         AND DTEMISSAO  = C_CORPONF.DTENTRVENDA
         AND IDENTRSAIDOP = 'S'
         AND IDSISTEMA  = 'FIS'
         AND CDSERIE    = V_SERIE
         AND DTEXPORTACAO IS NOT NULL;

      UPDATE MAPARESUMECF
         SET CDFILIALNF = NULL,
             NRLANCTONF = NULL
       WHERE CDFILIAL     = C_CORPONF.CDFILIAL     AND
             DTMAPARESECF = C_CORPONF.DTENTRVENDA  AND
             NRMAPARESECF = V_NRNOTAANTE;

      DELETE FROM IMPOSTONF
      WHERE (CDFILIAL||NRLANCTONF) IN (SELECT CDFILIAL||NRLANCTONF
                                       FROM NOTAFISCAL
                                       WHERE CDEMPRESA  = P_CDEMPRESA           AND
                                             CDINSCESTA = P_CDINSCESTA          AND
                                             DTEMISSAO  = C_CORPONF.DTENTRVENDA AND
                                             IDENTRSAIDOP = 'S'                 AND
                                             IDSISTEMA  = 'FIS'                 AND
                                             CDSERIE    = V_SERIE               AND
                                             DTEXPORTACAO IS NOT NULL);

      DELETE FROM NOTAFISCAL
      WHERE (CDFILIAL||NRLANCTONF) IN (SELECT CDFILIAL||NRLANCTONF
                                        FROM NOTAFISCAL
                                       WHERE CDEMPRESA  = P_CDEMPRESA           AND
                                             CDINSCESTA = P_CDINSCESTA          AND
                                             DTEMISSAO  = C_CORPONF.DTENTRVENDA AND
                                             IDENTRSAIDOP = 'S'                 AND
                                             IDSISTEMA  = 'FIS'                 AND
                                             CDSERIE    = V_SERIE               AND
                                             DTEXPORTACAO IS NOT NULL);

      IF V_NRNOTAANTE IS NULL THEN
         SELECT MAX(NRMAPARESECF)
         INTO V_NRNOTAFISC
         FROM MAPARESUMECF
         WHERE CDFILIAL     = C_CORPONF.CDFILIAL     AND
               DTMAPARESECF = C_CORPONF.DTENTRVENDA;

         IF V_NRNOTAFISC IS NULL THEN
            NOVO_CODIGO('MODELONF' || P_CDCTRLNUMENF , V_NRNOTAFISC);
            IF C_CORPONF.NRTAMNUMNFUT IS NULL THEN
               V_TAMNF := 7;
            ELSE
               V_TAMNF := C_CORPONF.NRTAMNUMNFUT;
            END IF;

            V_NRNOTAFISC := SUBSTR(V_NRNOTAFISC, ((20-V_TAMNF)+1), V_TAMNF);
         END IF;
      ELSE
         V_NRNOTAFISC := V_NRNOTAANTE;
      END IF;

      SELECT MAX(CDFILIAL)
      INTO V_FILIPROC
      FROM PARAMGERAL;

      NOVO_CODIGO('LANCNF/FILIAL' || V_FILIPROC, V_NRLANCTONF);
      V_NRLANCTONF := SUBSTR(V_NRLANCTONF, 11, 10);


      SELECT MAX(P.CDCLIENTE), MAX(C.IDTPIJURCLIE), MAX(C.NRINSJURCLIE)
      INTO V_CDCLIENTE, V_IDTPIJURNF, V_NRINSJURNF
      FROM PARAVEND P, CLIENTE C
      WHERE P.CDFILIAL  = C_CORPONF.CDFILIAL AND
            C.CDCLIENTE = P.CDCLIENTE;

      SELECT MIN(CDMODDOCFISC) CDMODDOCFISC
        INTO V_CDMODDOCFISC
        FROM MODDOCFISCTPOP
       WHERE CDTIPOOPER   = P_CDOPERACAO
         AND IDENTRSAIDOP = 'S';

      SELECT NVL(MAX(IDENDCFOPCLI),'P')
      INTO V_IDENDEMIS
      FROM CLIENTE
      WHERE (CDCLIENTE = V_CDCLIENTE);

      SELECT MAX(CDPAIS), MAX(SGESTADO), MAX(CDMUNICIPIO)
      INTO  V_PAISORIG, V_ESTAORIG, V_MUNIORIG
      FROM INSCRESTAD
      WHERE (CDEMPRESA  = P_CDEMPRESA) AND
            (CDINSCESTA = P_CDINSCESTA) ;

      SELECT MAX(CDPAIS), MAX(SGESTADO)
      INTO V_PAISDEST, V_ESTADEST
      FROM ENDECLIE
      WHERE (CDCLIENTE    = V_CDCLIENTE) AND
            (IDTPENDECLIE = V_IDENDEMIS);

      V_IDINTEREST := 'N';
      V_IDINTERNA  := 'N';
      IF ((V_PAISDEST = V_PAISORIG) AND (V_ESTADEST <> V_ESTAORIG)) THEN
         V_IDINTEREST := 'S';
      ELSIF (V_PAISDEST <> V_PAISORIG) THEN
         V_IDINTERNA := 'S';
      END IF;

      INSERT INTO NOTAFISCAL
         (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
          CDFILIEMIT,   IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  NRNOTAFISC,
          DTEMISSAO,    DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   IDENTRSAIDOP,
          CDTIPOOPER,   CDSERIE,      IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,
          IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    IDORIGDESTNF,
          DTEXPORTACAO, CDCLIENTE,    IDTPIJURNF,   NRINSJURNF,   CDMODDOCFISC)
      VALUES
         (V_FILIPROC, V_NRLANCTONF, P_CDEMPRESA, P_CDINSCESTA, C_CORPONF.CDINSCMUNI,
          C_CORPONF.CDFILIAL,  'S', 'S', 'N', DECODE(V_IDUTNRCUPOMNF, 'S', C_CORPONF.NRCUPOMFIS, V_NRNOTAFISC),
          C_CORPONF.DTENTRVENDA, C_CORPONF.DTENTRVENDA, NVL(C_CORPONF.VRVENDA,0), NVL(C_CORPONF.VRVENDA,0), 'S',
          P_CDOPERACAO, V_SERIE, 'N', 'A', 'N',
          'N', 'N', 'N', 'FIS', 'C',
          C_CORPONF.DTENTRVENDA, V_CDCLIENTE, V_IDTPIJURNF, V_NRINSJURNF, V_CDMODDOCFISC);

      V_ALIQTEMP := V_FILIPROC||V_NRLANCTONF;
      V_INCITEMP := V_FILIPROC||V_NRLANCTONF;
      V_CSTTEMP  := V_FILIPROC||V_NRLANCTONF;
      V_CFOPTEMP := V_FILIPROC||V_NRLANCTONF;

      V_SEQUIMPOSTNF := '01';

      FOR C_ITEMFISC IN ( SELECT CDEMPRESA, DTENTRVENDA, CDFILIAL, IDTPIMPOSFIS,CDCSTPROD,CFOPITEM,VRPEALPRODIT,SUM(VRUNIT),SUM(BASECALC) AS BASECALC ,SUM(VRIMPOSTO) AS VRIMPOSTO
                            FROM
                         (SELECT VD.CDEMPRESA, VD.DTENTRVENDA, VD.CDFILIAL, NVL(IP.IDTPIMPOSFIS,'F') AS IDTPIMPOSFIS,
                                CST_ITEM(VD.CDEMPRESA,P_CDINSCESTA,VD.CDFILIAL,V_NRLANCTONF,V_CDCLIENTE, P_CDOPERACAO, P.CDARVPROD) AS CDCSTPROD,
                                CFOP_ITEM(VD.CDEMPRESA, P_CDINSCESTA, VD.CDFILIAL, V_CDCLIENTE, P_CDOPERACAO, VD.DTENTRVENDA, P.CDARVPROD, V_PAISORIG, V_ESTAORIG, V_PAISDEST, V_ESTADEST) AS CFOPITEM,
                                NVL(IP.VRPEALPRODIT,0) AS VRPEALPRODIT, SUM(TRUNC(IT.VRUNITVEND+VRUNITVENDCL,2)) AS VRUNIT,
                                 TRUNC(SUM((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL))-NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)),2) AS BASECALC,
                                 TRUNC(SUM(((IT.QTPRODVEND * (IT.VRUNITVEND+IT.VRUNITVENDCL))-NVL(IT.VRDESITVEND,0) + NVL(IT.VRACRITVEND,0)) * (IP.VRPEALPRODIT/100)),2) AS VRIMPOSTO, VD.CDCAIXA
                           FROM VENDA VD, ITEMVENDA IT, PRODUTO P, CAIXAPERS CX,

                                (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                                   FROM MOVCAIXA
                                  WHERE IDTIPOMOVIVE <> 'T' )MV,

                                (SELECT CDFILIAL, CDCAIXA, NRSEQVENDA, NRSEQUITVEND, IDTPIMPOSFIS, VRPEALPRODIT
                                   FROM ITVENDAIMPOS IV, IMPOSTO I
                                  WHERE IV.CDIMPOSTO    = I.CDIMPOSTO
                                    AND I.IDTPIMPOSFIS <> 'S' ) IP

                          WHERE VD.CDEMPRESA    = C_CORPONF.CDEMPRESA
                            AND VD.CDCAIXA      = C_CORPONF.CDCAIXA
                            AND VD.CDFILIAL     = C_CORPONF.CDFILIAL
                            AND VD.IDSITUVENDA  = 'O'
                            AND IDTIPOVENDA     = 'S'
                            AND VD.DTENTRVENDA  = C_CORPONF.DTENTRVENDA
                            AND VD.CDFILIAL     = IT.CDFILIAL
                            AND VD.CDCAIXA      = IT.CDCAIXA
                            AND VD.NRSEQVENDA   = IT.NRSEQVENDA
                            AND VD.CDFILIAL     = MV.CDFILIAL
                            AND VD.CDCAIXA      = MV.CDCAIXA
                            AND VD.NRSEQVENDA   = MV.NRSEQVENDA
                            AND IT.CDPRODUTO    = P.CDPRODUTO
                            AND IT.CDFILIAL     = IP.CDFILIAL
                            AND IT.CDCAIXA      = IP.CDCAIXA
                            AND IT.NRSEQVENDA   = IP.NRSEQVENDA
                            AND IT.NRSEQUITVEND = IP.NRSEQUITVEND
                            AND CX.CDFILIAL     = VD.CDFILIAL
                            AND CX.CDCAIXAPERS  = VD.CDCAIXA
                            AND CX.IDTIPOSISTEMA <> 'SPS'
                          GROUP BY VD.CDEMPRESA, VD.CDFILIAL, VD.DTENTRVENDA, NVL(IP.IDTPIMPOSFIS,'F'), NVL(IP.VRPEALPRODIT,0), CST_ITEM(VD.CDEMPRESA,P_CDINSCESTA,VD.CDFILIAL,V_NRLANCTONF,V_CDCLIENTE, P_CDOPERACAO, P.CDARVPROD),
                                CFOP_ITEM(VD.CDEMPRESA, P_CDINSCESTA, VD.CDFILIAL, V_CDCLIENTE, P_CDOPERACAO, VD.DTENTRVENDA, P.CDARVPROD, V_PAISORIG, V_ESTAORIG, V_PAISDEST, V_ESTADEST),VD.CDCAIXA
                          ORDER BY VD.DTENTRVENDA)
                          GROUP BY CDEMPRESA, DTENTRVENDA, CDFILIAL, IDTPIMPOSFIS,CDCSTPROD,CFOPITEM,VRPEALPRODIT
                          ) LOOP

         IF (C_ITEMFISC.IDTPIMPOSFIS = 'T') THEN
            V_INCIDENCIA := '1';
            V_BASECALC   := C_ITEMFISC.BASECALC;
         ELSE
            IF (C_ITEMFISC.IDTPIMPOSFIS = 'F') THEN
               V_INCIDENCIA := '3';
               V_BASECALC := 0;
            ELSE
               V_INCIDENCIA := '2';
               V_BASECALC := 0;
            END IF;
         END IF;

         IF V_SEQUIMPOSTNF = '01' THEN
            IF NVL(C_CORPONF.NRCUPOMINI,'T') = NVL(C_CORPONF.NRCUPOMFIM,'T') THEN
               V_DSOBSFISCIT  := 'NF Subst. CF '||C_CORPONF.NRCUPOMINI;
            ELSE
               IF (C_CORPONF.NRCUPOMINI||C_CORPONF.NRCUPOMFIM IS NOT NULL) THEN
                  V_DSOBSFISCIT  := 'NF Subst. CF '||C_CORPONF.NRCUPOMINI||'/'||C_CORPONF.NRCUPOMFIM;
               ELSE
                  V_DSOBSFISCIT  := '';
               END IF;
            END IF;
         ELSE
            V_DSOBSFISCIT  := '';
         END IF;

         INSERT INTO IMPOSTONF
            (CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF,  VRPERREDBCNF, VRBASECALCNF,
             VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, IDIMPOSTONF, DSOBSFISCIT)
         VALUES
            (V_FILIPROC, V_NRLANCTONF, '00', V_SEQUIMPOSTNF, NVL(C_ITEMFISC.BASECALC,0), 0.00, V_BASECALC,
             NVL(C_ITEMFISC.VRPEALPRODIT,0), 0.00, NVL(C_ITEMFISC.VRIMPOSTO,0), V_INCIDENCIA,C_ITEMFISC.CDCSTPROD,
             SUBSTR(C_ITEMFISC.CFOPITEM,3,14), '1', V_DSOBSFISCIT);

         V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      END LOOP;

      UPDATE MAPARESUMECF
      SET CDFILIALNF = V_FILIPROC,
          NRLANCTONF = V_NRLANCTONF
      WHERE CDFILIAL     = C_CORPONF.CDFILIAL     AND
            DTMAPARESECF = C_CORPONF.DTENTRVENDA  AND
            NRMAPARESECF = V_NRNOTAFISC;

      V_NRSEQUITVEND := '01';

      FOR C_OUTROSIMP IN (SELECT P.CDARVPROD,
                                 SUM(TRUNC((I.QTPRODVEND * (I.VRUNITVEND+I.VRUNITVENDCL)),2)-NVL(I.VRDESITVEND,0) + NVL(I.VRACRITVEND,0)) AS VRLIQUIITEM
                          FROM VENDA V, ITEMVENDA I, PRODUTO P, CAIXAPERS C,
                               (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                                FROM MOVCAIXA
                                WHERE IDTIPOMOVIVE <> 'T' )M
                          WHERE V.CDEMPRESA    = C_CORPONF.CDEMPRESA   AND
                                V.CDFILIAL     = C_CORPONF.CDFILIAL    AND
                                V.IDSITUVENDA  = 'O'                   AND
                                IDTIPOVENDA     = 'S'                  AND
                                V.DTENTRVENDA  = C_CORPONF.DTENTRVENDA AND
                                V.CDFILIAL     = I.CDFILIAL            AND
                                V.CDCAIXA      = I.CDCAIXA             AND
                                V.NRSEQVENDA   = I.NRSEQVENDA          AND
                                I.CDPRODUTO    = P.CDPRODUTO           AND
                                V.CDFILIAL     = M.CDFILIAL            AND
                                V.CDCAIXA      = M.CDCAIXA             AND
                                V.NRSEQVENDA   = M.NRSEQVENDA          AND
                                V.CDFILIAL     = C.CDFILIAL            AND
                                V.CDCAIXA      = C.CDCAIXAPERS         AND
                                C.IDTIPOSISTEMA <> 'SPS'
                          GROUP BY P.CDARVPROD) LOOP

          CONSULTA_GRUPOFISCAL('C', V_CDCLIENTE, '', 'S', P_CDOPERACAO, V_CDGRUPOFISC);
          CONSULTA_INCIDENCIA('S', P_CDEMPRESA, C_OUTROSIMP.CDARVPROD, P_CDINSCESTA, P_CDOPERACAO, V_FILIPROC, V_NRLANCTONF, V_CDGRUPOFISC);
          CONSULTA_CST('S', P_CDEMPRESA, C_OUTROSIMP.CDARVPROD, P_CDINSCESTA, P_CDOPERACAO, V_FILIPROC, V_NRLANCTONF, V_CDGRUPOFISC, V_IDINTEREST, V_IDINTERNA);
          CONSULTA_CFOP('S', P_CDEMPRESA, C_OUTROSIMP.CDARVPROD, P_CDINSCESTA, P_CDOPERACAO, V_PAISORIG,
                         V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_FILIPROC, V_NRLANCTONF, V_CDGRUPOFISC, C_CORPONF.DTENTRVENDA);

          SELECT MAX(CDSITTRIBTMP) INTO V_SITUTRIBPR
          FROM CSTTEMP
          WHERE (NRCSTTEMP = V_CSTTEMP);

          SELECT MAX(CDFISOPETMP)
          INTO V_FISOPEITEM
          FROM CFOPTEMP
          WHERE NRCFOPTEMP = V_CFOPTEMP;

          FOR C_INCIDENCIA IN (SELECT DISTINCT (CDIMPOTEMP) AS CDIMPOTEMP, CDFISCTEMP, IDTRATIMPTMP,
                                      IDCONSISTENT, IDIMPORECUP
                               FROM INCITEMP IT, IMPOSTO IP
                               WHERE (IT.NRINCITEMP = V_INCITEMP)    AND
                                     (IP.CDIMPOSTO  = IT.CDIMPOTEMP) AND
                                     (IP.CDIMPOSTO  <> '00')         AND
                                     (IP.IDPRODNOTA = 'P')) LOOP

               CONSULTA_ALIQUOTA(C_INCIDENCIA.CDIMPOTEMP, 'S', P_CDEMPRESA, C_OUTROSIMP.CDARVPROD, P_CDINSCESTA, V_PAISORIG,
                                 V_ESTAORIG, V_PAISDEST, V_ESTADEST, V_MUNIORIG, C_OUTROSIMP.VRLIQUIITEM, C_CORPONF.DTENTRVENDA, V_FILIPROC, V_NRLANCTONF, V_CDGRUPOFISC);

               V_NRALIQTEMP := 0;
               V_PARDEDTMP  := 0;
               V_PREDBCTMP  := 0;
               V_ALIQUTMP   := 0;
               V_IMPOSTOIT  := 0;

               SELECT NVL(MAX(NRALIQTEMP),0), NVL(MAX(VRPARDEDTMP),0), NVL(MAX(VRPREDBCTMP),0), NVL(MAX(VRALIQUTMP),0),
                      NVL(MAX(IDTRIMPSTTMP), '0')
               INTO V_NRALIQTEMP, V_PARDEDTMP, V_PREDBCTMP, V_ALIQUTMP, V_TRATIMPST
               FROM ALIQTEMP
               WHERE (NRALIQTEMP = V_ALIQTEMP);

               V_TAXABASECALC := (100 - V_PREDBCTMP)/100;
               V_TAXAALIQUOTA := (V_ALIQUTMP/100);

               V_BASECALCIT   := C_OUTROSIMP.VRLIQUIITEM * V_TAXABASECALC;
               V_PERDBCALC    := 100 - V_PREDBCTMP;

               V_IMPOSTOIT   := (V_BASECALCIT * V_TAXAALIQUOTA) - V_PARDEDTMP;
               V_IDTRIMPSTII := V_TRATIMPST;
               V_CONTABCALC  := V_LIQUIITEM - (V_LIQUIITEM * V_TAXABASECALC);

               IF (V_IMPOSTOIT < 0) THEN
                  V_IMPOSTOIT := 0;
               END IF;

               INSERT INTO TRABITPROIMPOS(
                  CDFILIMPOIT, NRLANCIMPOIT, NRSEQIMPOIT, CDIMPOSTOIT, NRSEQITPRO, CDFISCIMPOIT,
                  CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT,
                  VRCONTIMPOIT, VRBCALCIMPOIT, VRIMPOSIT, IDERRIMPOIT, IDAVISIMPOIT, IDVALORINFO, IDTRIMPSTTI)
               VALUES(
                  V_FILIPROC, V_NRLANCTONF, V_NRSEQUITVEND, C_INCIDENCIA.CDIMPOTEMP, '1', C_INCIDENCIA.CDFISCTEMP,
                  V_SITUTRIBPR, V_FISOPEITEM, '', V_ALIQUTMP, V_PREDBCTMP, V_PARDEDTMP, V_BASECALCIT,
                  V_BASECALCIT, V_IMPOSTOIT, '00000', '00000', 'N', V_IDTRIMPSTII);

               V_NRSEQUITVEND := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_NRSEQUITVEND) + 1)),2,0);

               DELETE ALIQTEMP
               WHERE NRALIQTEMP = V_ALIQTEMP;
          END LOOP;

          DELETE INCITEMP
          WHERE NRINCITEMP = V_INCITEMP;

          DELETE CFOPTEMP
          WHERE NRCFOPTEMP = V_CFOPTEMP;

          DELETE CSTTEMP
          WHERE NRCSTTEMP = V_CSTTEMP;
      END LOOP;

      V_SEQUIMPOSTNF := '01';

      FOR C_IMPOSTONF IN (SELECT IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
                                 CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
                                 SUM(VRBCALCIMPOIT) AS VRBCALCIMPOIT, SUM(VRIMPOSIT) AS VRIMPOSIT
                          FROM TRABITPROIMPOS IT, IMPOSTO I
                          WHERE (CDFILIMPOIT  = V_FILIPROC)    AND
                                (NRLANCIMPOIT = V_NRLANCTONF)  AND
                                (CDIMPOSTOIT  = I.CDIMPOSTO) AND
                                ((((CDFISCIMPOIT = '1')) AND (IDIMPORECUP = 'S')) OR
                                 ((IDIMPORECUP <> 'S') AND (VRIMPOSIT <> 0)) OR (NRSEQITPRO = '3'))
                          GROUP BY IT.CDIMPOSTOIT, VRALIQIMPOIT, VRREDBCIMPOIT, VRPDEDIMPOIT, CDFISCIMPOIT,
                                   CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO
                          UNION
                          SELECT IT.CDIMPOSTOIT, 0 AS VRALIQIMPOIT, 0 AS VRREDBCIMPOIT, 0 AS VRPDEDIMPOIT, CDFISCIMPOIT,
                                 CDSTRIBIMPOIT, CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO, SUM(VRCONTIMPOIT) AS VRCONTIMPOIT,
                                 0 AS VRBCALCIMPOIT, 0 AS VRIMPOSIT
                          FROM TRABITPROIMPOS IT, IMPOSTO I
                          WHERE (CDFILIMPOIT  = V_FILIPROC)    AND
                                (NRLANCIMPOIT = V_NRLANCTONF)  AND
                                (CDIMPOSTOIT  = I.CDIMPOSTO) AND
                                (NRSEQITPRO   <> '3')        AND
                                ((((CDFISCIMPOIT <> '1')) AND (IDIMPORECUP = 'S')) OR
                                 ((IDIMPORECUP  <> 'S') AND (VRIMPOSIT = 0)))
                          GROUP BY IT.CDIMPOSTOIT, CDFISCIMPOIT, CDSTRIBIMPOIT,
                                   CDFOPERIMPOIT, CDSCFOPIMPOIT, NRSEQITPRO) LOOP

         INSERT INTO IMPOSTONF(
            CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
            VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF,
            IDIMPOSTONF)
         VALUES(
            V_FILIPROC, V_NRLANCTONF, C_IMPOSTONF.CDIMPOSTOIT, V_SEQUIMPOSTNF, C_IMPOSTONF.VRCONTIMPOIT,
            C_IMPOSTONF.VRREDBCIMPOIT, C_IMPOSTONF.VRBCALCIMPOIT, C_IMPOSTONF.VRALIQIMPOIT,
            C_IMPOSTONF.VRPDEDIMPOIT, C_IMPOSTONF.VRIMPOSIT, C_IMPOSTONF.CDFISCIMPOIT,
            C_IMPOSTONF.CDSTRIBIMPOIT, C_IMPOSTONF.CDFOPERIMPOIT, C_IMPOSTONF.CDSCFOPIMPOIT,
            C_IMPOSTONF.NRSEQITPRO);

         V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      END LOOP;

      DELETE TRABITPROIMPOS
      WHERE (CDFILIMPOIT  = V_FILIPROC) AND
            (NRLANCIMPOIT = V_NRLANCTONF);

   END LOOP;

   FOR C_LANC IN (SELECT IT.CDFILIALNF, IT.NRLANCTONF, MAX(VD.NRCUPOMFIS) NRCUPOMFIM, MIN(VD.NRCUPOMFIS) NRCUPOMINI
                  FROM  VENDA VD, FILIAL FI, ITEMVENDA IT, NOTAFISCAL NF, CAIXAPERS CX,
                       (SELECT DISTINCT CDFILIAL, CDCAIXA, NRSEQVENDA
                        FROM MOVCAIXA
                        WHERE IDTIPOMOVIVE <> 'T' )MV
                  WHERE FI.CDEMPRESA    = P_CDEMPRESA       AND
                        FI.CDINSCESTA   = P_CDINSCESTA      AND
                        VD.CDFILIAL     = FI.CDFILIAL       AND
                        VD.IDSITUVENDA  = 'O'               AND
                        IDTIPOVENDA     = 'S'               AND
                        VD.DTENTRVENDA BETWEEN P_DTINICIAL  AND P_DTFINAL AND
                        VD.CDFILIAL     = MV.CDFILIAL       AND
                        VD.CDCAIXA      = MV.CDCAIXA        AND
                        VD.NRSEQVENDA   = MV.NRSEQVENDA     AND
                        VD.CDFILIAL     = IT.CDFILIAL       AND
                        VD.CDCAIXA      = IT.CDCAIXA        AND
                        VD.NRSEQVENDA   = IT.NRSEQVENDA     AND
                        IT.CDFILIALNF   = NF.CDFILIAL       AND
                        IT.NRLANCTONF   = NF.NRLANCTONF     AND
                        NF.IDSTATUS IN ('A', 'E')           AND
                        CX.CDFILIAL     = VD.CDFILIAL       AND
                        CX.CDCAIXAPERS  = VD.CDCAIXA        AND
                        CX.IDTIPOSISTEMA <> 'SPS'
                  GROUP BY IT.CDFILIALNF, IT.NRLANCTONF) LOOP

      IF NVL(C_LANC.NRCUPOMINI,'T') = NVL(C_LANC.NRCUPOMFIM,'T') THEN
         UPDATE IMPOSTONF
         SET VRCONTABILNF = 0.00,
             VRBASECALCNF = 0.00,
             VRALIQNF     = 0.00,
             VRIMPOSTONF  = 0.00,
             VRPERREDBCNF = 0.00,
             CDFISCALNF   = '3',
             DSOBSFISCIT  = 'Ref.Cupom: '||C_LANC.NRCUPOMINI
         WHERE CDFILIAL   = C_LANC.CDFILIALNF AND
               NRLANCTONF = C_LANC.NRLANCTONF AND
               CDIMPOSTO  = '00';
      ELSE

         UPDATE IMPOSTONF
         SET VRCONTABILNF = 0.00,
             VRBASECALCNF = 0.00,
             VRALIQNF     = 0.00,
             VRIMPOSTONF  = 0.00,
             VRPERREDBCNF = 0.00,
             CDFISCALNF   = '3',
             DSOBSFISCIT  = 'Ref. Cupom: '||C_LANC.NRCUPOMINI||' a '||C_LANC.NRCUPOMFIM
         WHERE CDFILIAL   = C_LANC.CDFILIALNF AND
               NRLANCTONF = C_LANC.NRLANCTONF AND
               CDIMPOSTO  = '00';
      END IF;

   END LOOP;

/*ROTINA PARA GERAO DO MAPA RESUMO PARA AS NF'S QUE AO SER EMITIDAS GERAM CUPOM FISCAL */

   FOR C_NOTAFISCAL IN (SELECT NF.CDEMPRESA, NF.CDINSCESTA, NF.CDINSCMUNI, NF.CDFILIEMIT, NF.DTEMISSAO,
                               P.NRTAMNUMNFUT, SUM(NF.VRNOTAFISC) VRNOTAFISC
                        FROM NOTAFISCAL NF, SERIENF S, PARAMFILIAL P
                        WHERE NF.CDEMPRESA    = P_CDEMPRESA    AND
                              NF.CDINSCESTA   = P_CDINSCESTA   AND
                              NF.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL AND
                              NF.IDENTRSAIDOP = 'S'            AND
                              NF.IDSTATUS IN ('A', 'E')        AND
                              NVL(NF.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP') AND
                              NF.CDFILIEMIT   = P.CDFILIAL     AND
                              NF.CDEMPRESA    = S.CDEMPRESA    AND
                              NF.CDINSCESTA   = S.CDINSCESTA   AND
                              NF.CDINSCMUNI   = S.CDINSCMUNI   AND
                              NF.CDSERIE      = S.CDSERIE      AND
                              S.IDUTLEMCUPOM  = 'S'
                        GROUP BY NF.CDEMPRESA, NF.CDINSCESTA, NF.CDINSCMUNI, NF.CDFILIEMIT, NF.DTEMISSAO, P.NRTAMNUMNFUT) LOOP

      SELECT MAX(NRNOTAFISC)
      INTO V_NRNOTAANTE
      FROM NOTAFISCAL
      WHERE CDEMPRESA  = P_CDEMPRESA            AND
            CDINSCESTA = P_CDINSCESTA           AND
            DTEMISSAO  = C_NOTAFISCAL.DTEMISSAO AND
            IDENTRSAIDOP = 'S'                  AND
            IDSISTEMA  = 'FIS'                  AND
            CDSERIE    = 'ECF'                  AND
            DTEXPORTACAO IS NOT NULL;

      SELECT MAX(NRNOTAFISC), MAX(NRLANCTONF)
      INTO V_LANCTEMP, V_NRLANCTEMP
      FROM NOTAFISCAL
      WHERE CDEMPRESA  = P_CDEMPRESA            AND
            CDINSCESTA = P_CDINSCESTA           AND
            DTEMISSAO  = C_NOTAFISCAL.DTEMISSAO AND
            IDENTRSAIDOP = 'S'                  AND
            IDSISTEMA  = 'FIS'                  AND
            CDSERIE    = 'ECF'                  AND
            DTEXPORTACAO IS NOT NULL;

      SELECT MAX(CDFILIAL)
      INTO V_FILIPROC
      FROM PARAMGERAL;

      NOVO_CODIGO('LANCNF/FILIAL' || V_FILIPROC, V_NRLANCTONF);
      V_NRLANCTONF := SUBSTR(V_NRLANCTONF, 11, 10);

      NOVO_CODIGO('MODELONF' || P_CDCTRLNUMENF , V_NRNOTAFISC);
      IF C_NOTAFISCAL.NRTAMNUMNFUT IS NULL THEN
         V_TAMNF := 7;
      ELSE
         V_TAMNF := C_NOTAFISCAL.NRTAMNUMNFUT;
      END IF;

      V_NRNOTAFISC := SUBSTR(V_NRNOTAFISC, ((20-V_TAMNF)+1), V_TAMNF);

      SELECT MAX(P.CDCLIENTE), MAX(C.IDTPIJURCLIE), MAX(C.NRINSJURCLIE)
      INTO V_CDCLIENTE, V_IDTPIJURNF, V_NRINSJURNF
      FROM PARAVEND P, CLIENTE C
      WHERE P.CDFILIAL  = C_NOTAFISCAL.CDFILIEMIT AND
            C.CDCLIENTE = P.CDCLIENTE;

      SELECT MIN(CDMODDOCFISC) CDMODDOCFISC
        INTO V_CDMODDOCFISC
        FROM MODDOCFISCTPOP
       WHERE CDTIPOOPER   = P_CDOPERACAO
         AND IDENTRSAIDOP = 'S';      

      IF NOT V_LANCTEMP IS NULL THEN
         UPDATE NOTAFISCAL
         SET VRNOTAFISC = VRNOTAFISC + C_NOTAFISCAL.VRNOTAFISC
         WHERE CDEMPRESA  = P_CDEMPRESA            AND
               CDINSCESTA = P_CDINSCESTA           AND
               DTEMISSAO  = C_NOTAFISCAL.DTEMISSAO AND
               CDFILIAL   = V_FILIPROC             AND
               NRLANCTONF = V_NRLANCTEMP           AND
               IDENTRSAIDOP = 'S'                  AND
               IDSISTEMA  = 'FIS'                  AND
               CDSERIE    = 'ECF'                  AND
               DTEXPORTACAO IS NOT NULL;
      ELSE
         IF NOT V_NRNOTAANTE IS NULL THEN
           DELETE FROM IMPOSTONF
           WHERE (CDFILIAL||NRLANCTONF) IN (SELECT CDFILIAL||NRLANCTONF
                                            FROM NOTAFISCAL
                                            WHERE CDEMPRESA  = P_CDEMPRESA            AND
                                                  CDINSCESTA = P_CDINSCESTA           AND
                                                  DTEMISSAO  = C_NOTAFISCAL.DTEMISSAO AND
                                                  IDENTRSAIDOP = 'S'                  AND
                                                  IDSISTEMA  = 'FIS'                  AND
                                                  CDSERIE    = 'ECF'                  AND
                                                  DTEXPORTACAO IS NOT NULL);

           DELETE FROM NOTAFISCAL
           WHERE (CDFILIAL||NRLANCTONF) IN (SELECT CDFILIAL||NRLANCTONF
                                             FROM NOTAFISCAL
                                            WHERE CDEMPRESA  = P_CDEMPRESA            AND
                                                  CDINSCESTA = P_CDINSCESTA           AND
                                                  DTEMISSAO  = C_NOTAFISCAL.DTEMISSAO AND
                                                  IDENTRSAIDOP = 'S'                  AND
                                                  IDSISTEMA  = 'FIS'                  AND
                                                  CDSERIE    = 'ECF'                  AND
                                                  DTEXPORTACAO IS NOT NULL);
           INSERT INTO NOTAFISCAL
              (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
               CDFILIEMIT,   IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  NRNOTAFISC,
               DTEMISSAO,    DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   IDENTRSAIDOP,
               CDTIPOOPER,   CDSERIE,      IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,
               IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    IDORIGDESTNF,
               DTEXPORTACAO, CDCLIENTE,    IDTPIJURNF,   NRINSJURNF,   CDMODDOCFISC)
           VALUES
              (V_FILIPROC, V_NRLANCTONF, P_CDEMPRESA, P_CDINSCESTA, C_NOTAFISCAL.CDINSCMUNI,
               C_NOTAFISCAL.CDFILIEMIT,  'S', 'S', 'N', V_NRNOTAANTE,
               C_NOTAFISCAL.DTEMISSAO, C_NOTAFISCAL.DTEMISSAO, NVL(C_NOTAFISCAL.VRNOTAFISC,0), NVL(C_NOTAFISCAL.VRNOTAFISC,0), 'S',
               P_CDOPERACAO, 'ECF', 'N', 'A', 'N', 'N', 'N', 'N', 'FIS', 'C',
               C_NOTAFISCAL.DTEMISSAO, V_CDCLIENTE, V_IDTPIJURNF, V_NRINSJURNF, V_CDMODDOCFISC);
         ELSE
            INSERT INTO NOTAFISCAL
               (CDFILIAL,     NRLANCTONF,   CDEMPRESA,    CDINSCESTA,   CDINSCMUNI,
                CDFILIEMIT,   IDBLOQUEADO,  IDDOCFISCAL,  IDDOCFINANC,  NRNOTAFISC,
                DTEMISSAO,    DTENTRSAID,   VRPRODUTOS,   VRNOTAFISC,   IDENTRSAIDOP,
                CDTIPOOPER,   CDSERIE,      IDDOCCONTAB,  IDSTATUS,     IDDOCFATUR,
                IDDOCFISCENT, IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA,    IDORIGDESTNF,
                DTEXPORTACAO, CDCLIENTE,    IDTPIJURNF,   NRINSJURNF,   CDMODDOCFISC)
            VALUES
               (V_FILIPROC, V_NRLANCTONF, P_CDEMPRESA, P_CDINSCESTA, C_NOTAFISCAL.CDINSCMUNI,
                C_NOTAFISCAL.CDFILIEMIT,  'S', 'S', 'N', V_NRNOTAFISC,
                C_NOTAFISCAL.DTEMISSAO, C_NOTAFISCAL.DTEMISSAO, NVL(C_NOTAFISCAL.VRNOTAFISC,0), NVL(C_NOTAFISCAL.VRNOTAFISC,0), 'S',
                P_CDOPERACAO, 'ECF', 'N', 'A', 'N',
                'N', 'N', 'N', 'FIS', 'C',
                C_NOTAFISCAL.DTEMISSAO, V_CDCLIENTE, V_IDTPIJURNF, V_NRINSJURNF, V_CDMODDOCFISC);

         END IF;
      END IF;

      FOR C_IMPOSTONF IN (
          SELECT N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                 IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                 CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP,
                 SUM(VRBASECALCIT) AS VRBASECALCIT, SUM(VRIMPOSTOIT) AS VRIMPOSTOIT, NRITPROIMPOS
          FROM NOTAFISCAL N, SERIENF S, ITEMPROIMPOS IT, IMPOSTO I
          WHERE (N.CDEMPRESA    = P_CDEMPRESA)   AND
                (N.CDINSCESTA   = P_CDINSCESTA)  AND
                (N.DTEMISSAO    = C_NOTAFISCAL.DTEMISSAO) AND
                (N.IDENTRSAIDOP = 'S')           AND
                (N.IDSTATUS IN ('A', 'E'))       AND
                (NVL(N.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP')) AND
                (N.CDEMPRESA    = S.CDEMPRESA)   AND
                (N.CDINSCESTA   = S.CDINSCESTA)  AND
                (N.CDINSCMUNI   = S.CDINSCMUNI)  AND
                (N.CDSERIE      = S.CDSERIE)     AND
                (S.IDUTLEMCUPOM = 'S')           AND
                (IT.CDFILIAL    = N.CDFILIAL)    AND
                (IT.NRLANCTONF  = N.NRLANCTONF)  AND
                (IT.CDIMPOSTO = I.CDIMPOSTO)     AND
                (((CDFISCALIT  = '1') AND (IDIMPORECUP = 'S')) OR
                 ((IDIMPORECUP <> 'S') AND (VRALIQITEM <> 0 )))
          GROUP BY N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                   IT.CDIMPOSTO, VRALIQITEM, VRPERREDBCIT, VRPARDEDIT, CDFISCALIT,
                   CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, NRITPROIMPOS
          UNION
          SELECT N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                 IT.CDIMPOSTO, 0 AS VRALIQITEM, 0 AS VRPERREDBCIT, 0 AS VRPARDEDIT, CDFISCALIT,
                 CDSITUTRIBIT, CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, SUM(VRCONTITIMP) AS VRCONTITIMP,
                 0 AS VRBASECALCIT, 0 AS VRIMPOSTOIT, NRITPROIMPOS
          FROM NOTAFISCAL N, SERIENF S, ITEMPROIMPOS IT, IMPOSTO I
          WHERE (N.CDEMPRESA    = P_CDEMPRESA)   AND
                (N.CDINSCESTA   = P_CDINSCESTA)  AND
                (N.DTEMISSAO    = C_NOTAFISCAL.DTEMISSAO) AND
                (N.IDENTRSAIDOP = 'S')           AND
                (N.IDSTATUS IN ('A', 'E'))       AND
                (NVL(N.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP')) AND
                (N.CDEMPRESA    = S.CDEMPRESA)   AND
                (N.CDINSCESTA   = S.CDINSCESTA)  AND
                (N.CDINSCMUNI   = S.CDINSCMUNI)  AND
                (N.CDSERIE      = S.CDSERIE)     AND
                (S.IDUTLEMCUPOM = 'S')           AND
                (IT.CDFILIAL    = N.CDFILIAL)    AND
                (IT.NRLANCTONF  = N.NRLANCTONF)  AND
                (((IT.CDFISCALIT <> '1') AND (IDIMPORECUP = 'S')) OR
                 ((I.IDIMPORECUP  <> 'S') AND (VRALIQITEM = 0) ))
          GROUP BY N.CDEMPRESA, N.CDINSCESTA, N.CDINSCMUNI, N.CDFILIEMIT, N.DTEMISSAO,
                   IT.CDIMPOSTO, CDFISCALIT, CDSITUTRIBIT,
                   CDFISCOPERIT, CDSUFXCFOPIT, IDTRIMPSTII, NRITPROIMPOS) LOOP

          IF NOT V_LANCTEMP IS NULL THEN
             SELECT MAX(CDIMPOSTO)
             INTO V_CDIMPOSTO
             FROM IMPOSTONF
             WHERE CDFILIAL     = V_FILIPROC               AND
                   NRLANCTONF   = V_NRLANCTEMP             AND
                   CDIMPOSTO    = C_IMPOSTONF.CDIMPOSTO    AND
                   VRALIQNF     = C_IMPOSTONF.VRALIQITEM   AND
                   CDFISCALNF   = C_IMPOSTONF.CDFISCALIT   AND
                   CDSITUTRIBNF = C_IMPOSTONF.CDSITUTRIBIT AND
                   CDFISCOPERNF = C_IMPOSTONF.CDFISCOPERIT AND
                   IDIMPOSTONF  = C_IMPOSTONF.NRITPROIMPOS;

             IF V_CDIMPOSTO IS NULL THEN
                SELECT MAX(NRIMPOSNF)
                INTO V_SEQUIMPOSTNF
                FROM IMPOSTONF
                WHERE CDFILIAL   = V_FILIPROC AND
                      NRLANCTONF = V_NRLANCTEMP;

                V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);

                INSERT INTO IMPOSTONF(
                   CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                   VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF)
                VALUES(
                   V_FILIPROC, V_NRLANCTEMP, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, C_IMPOSTONF.VRCONTITIMP,
                   C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM,
                   C_IMPOSTONF.VRPARDEDIT, C_IMPOSTONF.VRIMPOSTOIT, C_IMPOSTONF.CDFISCALIT,
                   C_IMPOSTONF.CDSITUTRIBIT, C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS);
             ELSE
                UPDATE IMPOSTONF
                SET VRCONTABILNF = VRCONTABILNF + C_IMPOSTONF.VRCONTITIMP,
                    VRBASECALCNF = VRBASECALCNF + C_IMPOSTONF.VRBASECALCIT,
                    VRIMPOSTONF  = VRIMPOSTONF  + C_IMPOSTONF.VRIMPOSTOIT
                WHERE CDFILIAL     = V_FILIPROC               AND
                      NRLANCTONF   = V_NRLANCTEMP             AND
                      CDIMPOSTO    = C_IMPOSTONF.CDIMPOSTO    AND
                      VRALIQNF     = C_IMPOSTONF.VRALIQITEM   AND
                      CDFISCALNF   = C_IMPOSTONF.CDFISCALIT   AND
                      CDSITUTRIBNF = C_IMPOSTONF.CDSITUTRIBIT AND
                      IDIMPOSTONF  = C_IMPOSTONF.NRITPROIMPOS;
             END IF;
          ELSE
             SELECT MAX(CDIMPOSTO)
             INTO V_CDIMPOSTO
             FROM IMPOSTONF
             WHERE CDFILIAL     = V_FILIPROC               AND
                   NRLANCTONF   = V_NRLANCTONF             AND
                   CDIMPOSTO    = C_IMPOSTONF.CDIMPOSTO    AND
                   VRALIQNF     = C_IMPOSTONF.VRALIQITEM   AND
                   CDFISCALNF   = C_IMPOSTONF.CDFISCALIT   AND
                   CDSITUTRIBNF = C_IMPOSTONF.CDSITUTRIBIT AND
                   CDFISCOPERNF = C_IMPOSTONF.CDFISCOPERIT AND
                   IDIMPOSTONF  = C_IMPOSTONF.NRITPROIMPOS;

             IF V_CDIMPOSTO IS NULL THEN
                INSERT INTO IMPOSTONF(
                   CDFILIAL, NRLANCTONF, CDIMPOSTO, NRIMPOSNF, VRCONTABILNF, VRPERREDBCNF, VRBASECALCNF,
                   VRALIQNF, VRPARDEDNF, VRIMPOSTONF, CDFISCALNF, CDSITUTRIBNF, CDFISCOPERNF, CDSUFXCFOPNF, IDIMPOSTONF)
                VALUES(
                   V_FILIPROC, V_NRLANCTONF, C_IMPOSTONF.CDIMPOSTO, V_SEQUIMPOSTNF, C_IMPOSTONF.VRCONTITIMP,
                   C_IMPOSTONF.VRPERREDBCIT, C_IMPOSTONF.VRBASECALCIT, C_IMPOSTONF.VRALIQITEM,
                   C_IMPOSTONF.VRPARDEDIT, C_IMPOSTONF.VRIMPOSTOIT, C_IMPOSTONF.CDFISCALIT,
                   C_IMPOSTONF.CDSITUTRIBIT, C_IMPOSTONF.CDFISCOPERIT, C_IMPOSTONF.CDSUFXCFOPIT, C_IMPOSTONF.NRITPROIMPOS);
             ELSE
                UPDATE IMPOSTONF
                SET VRCONTABILNF = VRCONTABILNF + C_IMPOSTONF.VRCONTITIMP,
                    VRBASECALCNF = VRBASECALCNF + C_IMPOSTONF.VRBASECALCIT,
                    VRIMPOSTONF  = VRIMPOSTONF  + C_IMPOSTONF.VRIMPOSTOIT
                WHERE CDFILIAL     = V_FILIPROC               AND
                      NRLANCTONF   = V_NRLANCTONF             AND
                      CDIMPOSTO    = C_IMPOSTONF.CDIMPOSTO    AND
                      VRALIQNF     = C_IMPOSTONF.VRALIQITEM   AND
                      CDFISCALNF   = C_IMPOSTONF.CDFISCALIT   AND
                      CDSITUTRIBNF = C_IMPOSTONF.CDSITUTRIBIT AND
                      IDIMPOSTONF  = C_IMPOSTONF.NRITPROIMPOS;
             END IF;
          END IF;
          V_SEQUIMPOSTNF := LPAD(RTRIM(TO_CHAR(TO_NUMBER(V_SEQUIMPOSTNF) + 1)),2,0);
      END LOOP;

   END LOOP;

   FOR C_UPDATENOTA IN (SELECT CDFILIAL, NRLANCTONF
                          FROM NOTAFISCAL
                         WHERE CDEMPRESA  = P_CDEMPRESA
                           AND CDINSCESTA = P_CDINSCESTA
                           AND DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                           AND IDENTRSAIDOP = 'S'
                           AND IDSISTEMA  = 'FIS'
                           AND CDSERIE    = 'ECF'
                           AND DTEXPORTACAO IS NOT NULL) LOOP
      UPDATE NOTAFISCAL
         SET IDSISTEMA = 'FIS'
       WHERE CDFILIAL   = C_UPDATENOTA.CDFILIAL
         AND NRLANCTONF = C_UPDATENOTA.NRLANCTONF;
   END LOOP;

   FOR C_ATUALIZA IN (SELECT NF.CDFILIAL, NF.NRLANCTONF
                        FROM NOTAFISCAL NF, SERIENF S
                       WHERE NF.CDEMPRESA    = P_CDEMPRESA
                         AND NF.CDINSCESTA   = P_CDINSCESTA
                         AND NF.DTEMISSAO BETWEEN P_DTINICIAL AND P_DTFINAL
                         AND NF.IDENTRSAIDOP = 'S'
                         AND NF.IDSTATUS IN ('A', 'E')
                         AND NVL(NF.IDSISTEMA, 'DFS') NOT IN ('REC', 'PAG', 'CMP', 'SUP')
                         AND NF.CDEMPRESA   = S.CDEMPRESA
                         AND NF.CDINSCESTA  = S.CDINSCESTA
                         AND NF.CDINSCMUNI  = S.CDINSCMUNI
                         AND NF.CDSERIE     = S.CDSERIE
                         AND S.IDUTLEMCUPOM = 'S' ) LOOP


      SELECT MAX(SUBSTR(DSDADOADIC,8,6))
        INTO V_NRCUPOM
        FROM DADOSADIC
       WHERE CDFILIAL = C_ATUALIZA.CDFILIAL     
         AND NRLANCTONF = C_ATUALIZA.NRLANCTONF
         AND SUBSTR(DSDADOADIC,1,5) = 'Cupom';

      IF NOT (V_NRCUPOM IS NULL) THEN
         UPDATE IMPOSTONF
            SET VRCONTABILNF = 0.00,
                VRBASECALCNF = 0.00,
                VRALIQNF     = 0.00,
                VRIMPOSTONF  = 0.00,
                VRPERREDBCNF = 0.00,
                CDFISCALNF   = '3',
                DSOBSFISCIT  = 'Ref.Cupom: '||V_NRCUPOM
          WHERE CDFILIAL   = C_ATUALIZA.CDFILIAL
            AND NRLANCTONF = C_ATUALIZA.NRLANCTONF
            AND CDIMPOSTO  = '00';
      END IF;
   END LOOP;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('GERANF_MPR_VENDA','5.50.xxx'); END;
/

